import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { htmlImgProps } from './types';
var BASE_CLASS = 'sui-AtomImage';
var BASE_CLASS_FIGURE = BASE_CLASS + "-figure";
var CLASS_PLACEHOLDER = BASE_CLASS_FIGURE + "--placeholder";
var CLASS_SKELETON = BASE_CLASS_FIGURE + "--skeleton";
var CLASS_IMAGE = BASE_CLASS + "-image";
var CLASS_SPINNER = BASE_CLASS + "-spinner";
var CLASS_ERROR = BASE_CLASS + "-error";

var Error = function Error(_ref // eslint-disable-line react/prop-types
) {
  var className = _ref.className,
      Icon = _ref.icon,
      text = _ref.text;
  return React.createElement("div", {
    className: className
  }, Icon, React.createElement("p", null, text));
};

var AtomImage =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(AtomImage, _Component);

  function AtomImage() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      loading: true,
      error: false
    };
    _this.imageRef = React.createRef();

    _this.handleLoad = function () {
      var onLoad = _this.props.onLoad;

      _this.setState({
        loading: false
      });

      onLoad && onLoad();
    };

    _this.handleError = function () {
      var onError = _this.props.onError;

      _this.setState({
        error: true,
        loading: false
      });

      onError && onError();
    };

    return _this;
  }

  var _proto = AtomImage.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var img = this.imageRef.current;

    if (img && img.complete && this.state.loading) {
      this.handleLoad();
    }
  };

  _proto.render = function render() {
    var _this$props = this.props,
        placeholder = _this$props.placeholder,
        skeleton = _this$props.skeleton,
        bgStyles = _this$props.bgStyles,
        Spinner = _this$props.spinner,
        errorIcon = _this$props.errorIcon,
        errorText = _this$props.errorText,
        onError = _this$props.onError,
        onLoad = _this$props.onLoad,
        imgProps = _objectWithoutProperties(_this$props, ["placeholder", "skeleton", "bgStyles", "spinner", "errorIcon", "errorText", "onError", "onLoad"]);

    var _this$state = this.state,
        loading = _this$state.loading,
        error = _this$state.error;
    var figureStyles = {
      backgroundImage: "url(" + (placeholder || skeleton) + ")"
    };
    var SpinnerExtended = Spinner && React.cloneElement(Spinner, {
      className: CLASS_SPINNER
    });
    return React.createElement("div", {
      className: this.classNames
    }, React.createElement("figure", {
      className: this.classNamesFigure,
      style: !error && (placeholder || skeleton) ? figureStyles : {}
    }, React.createElement("img", Object.assign({
      className: CLASS_IMAGE,
      onLoad: this.handleLoad,
      onError: this.handleError,
      ref: this.imageRef
    }, imgProps))), !error && loading && SpinnerExtended, error && React.createElement(Error, {
      className: CLASS_ERROR,
      icon: errorIcon,
      text: errorText
    }));
  };

  _createClass(AtomImage, [{
    key: "classNames",
    get: function get() {
      var _this$state2 = this.state,
          loading = _this$state2.loading,
          error = _this$state2.error;
      return cx(BASE_CLASS, "is-" + (loading ? 'loading' : 'loaded'), error && "is-error");
    }
  }, {
    key: "classNamesFigure",
    get: function get() {
      var _this$props2 = this.props,
          placeholder = _this$props2.placeholder,
          skeleton = _this$props2.skeleton;
      return cx(BASE_CLASS_FIGURE, placeholder && CLASS_PLACEHOLDER, skeleton && CLASS_SKELETON);
    }
  }]);

  return AtomImage;
}(Component);

AtomImage.displayName = 'AtomImage';
export default AtomImage;